Bug 1685132 (CVE-2019-9021) - CVE-2019-9021 php: Heap-based buffer over-read in PHAR reading functions
Summary: CVE-2019-9021 php: Heap-based buffer over-read in PHAR reading functions
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2019-9021
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
low
low
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 1709125 1709126 1709127 1709128 1709129
Blocks: 1680558
TreeView+ depends on / blocked
 
Reported: 2019-03-04 12:32 UTC by Dhananjay Arunesh
Modified: 2020-04-28 15:31 UTC (History)
5 users (show)

Fixed In Version: php 5.6.40, php 7.1.26, php 7.2.14, php 7.3.1
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-08-19 08:47:41 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHBA-2019:3727 None None None 2019-11-06 10:12:32 UTC
Red Hat Product Errata RHSA-2019:2519 None None None 2019-08-19 08:42:41 UTC
Red Hat Product Errata RHSA-2019:3299 None None None 2019-11-01 13:01:24 UTC
Red Hat Product Errata RHSA-2020:1624 None None None 2020-04-28 15:31:41 UTC

Description Dhananjay Arunesh 2019-03-04 12:32:23 UTC
An issue was discovered in PHP before 5.6.40, 7.x before 7.1.26, 7.2.x before 7.2.14, and 7.3.x before 7.3.1. A heap-based buffer over-read in PHAR reading functions in the PHAR extension may allow an attacker to read allocated or unallocated memory past the actual data when trying to parse the file name, a different vulnerability than CVE-2018-20783. This is related to phar_detect_phar_fname_ext in ext/phar/phar.c.

References:
https://bugs.php.net/bug.php?id=77247

Upstrean commit:
http://git.php.net/?p=php-src.git;a=commit;h=428d8164ffcf6f75a6cc9d4056e54bfd450dac03
http://git.php.net/?p=php-src.git;a=commit;h=78bd3477745f1ada9578a79f61edb41886bec1cb
http://git.php.net/?p=php-src.git;a=commit;h=9d388b95c54ea053ce6f194defe1ff6673195747

Comment 1 Huzaifa S. Sidhpurwala 2019-05-13 04:51:15 UTC
Analysis: 

Essentially an OOB read in the PHAR code, which can be triggered by malicious PHAR files. Obviously the php script needs to allow users (attackers) to upload arbitrary PHAR files and they need to be processed via Phar() function. Impact is PHP crash due to OOB read.

Comment 3 errata-xmlrpc 2019-08-19 08:42:41 UTC
This issue has been addressed in the following products:

  Red Hat Software Collections for Red Hat Enterprise Linux 7
  Red Hat Software Collections for Red Hat Enterprise Linux 7.4 EUS
  Red Hat Software Collections for Red Hat Enterprise Linux 7.5 EUS
  Red Hat Software Collections for Red Hat Enterprise Linux 7.6 EUS

Via RHSA-2019:2519 https://access.redhat.com/errata/RHSA-2019:2519

Comment 4 Product Security DevOps Team 2019-08-19 08:47:41 UTC
This bug is now closed. Further updates for individual products will be reflected on the CVE page(s):

https://access.redhat.com/security/cve/cve-2019-9021

Comment 5 errata-xmlrpc 2019-11-01 13:01:23 UTC
This issue has been addressed in the following products:

  Red Hat Software Collections for Red Hat Enterprise Linux 7
  Red Hat Software Collections for Red Hat Enterprise Linux 7.5 EUS
  Red Hat Software Collections for Red Hat Enterprise Linux 7.6 EUS
  Red Hat Software Collections for Red Hat Enterprise Linux 7.7 EUS

Via RHSA-2019:3299 https://access.redhat.com/errata/RHSA-2019:3299

Comment 6 errata-xmlrpc 2020-04-28 15:31:39 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 8

Via RHSA-2020:1624 https://access.redhat.com/errata/RHSA-2020:1624


Note You need to log in before you can comment on or make changes to this bug.